import { DocumentIoType } from "kryo/types/document";
import { Uint4 } from "semantic-types";
import { ColorStop } from "../color-stop";
import { Sfixed16P16 } from "../fixed-point/sfixed16p16";
import { Sfixed8P8 } from "../fixed-point/sfixed8p8";
import { FilterType } from "./_type";
export interface GradientBevel {
    filter: FilterType.GradientBevel;
    gradient: ColorStop[];
    blurX: Sfixed16P16;
    blurY: Sfixed16P16;
    angle: Sfixed16P16;
    distance: Sfixed16P16;
    strength: Sfixed8P8;
    inner: boolean;
    knockout: boolean;
    compositeSource: boolean;
    onTop: boolean;
    passes: Uint4;
}
export declare const $GradientBevel: DocumentIoType<GradientBevel>;
