import { DocumentIoType } from "kryo/types/document";
import { Vector2D } from "../vector-2d";
import { Edge } from "./edge";
export interface MorphEdge extends Edge {
    /**
     * Difference between the edge start and edge end in the end-state of the
     * morph shape.
     */
    morphDelta: Vector2D;
    /**
     * Difference between the edge start and quadratic bezier control point (if
     * any) in the end-state of the morph shape.
     */
    morphControlDelta?: Vector2D;
}
export declare const $MorphEdge: DocumentIoType<MorphEdge>;
