import { DocumentIoType } from "kryo/types/document";
import { Mp3ChannelMode } from "./mp3-channel-mode";
import { Mp3Layer } from "./mp3-layer";
import { MpegVersion } from "./mpeg-version";
export interface Mp3Frame {
    mpegVersion: MpegVersion;
    layer: Mp3Layer;
    bitrate: number;
    samplingRate: number;
    useFramePadding: boolean;
    channelMode: Mp3ChannelMode;
    isCopyrighted: boolean;
    isOriginal: boolean;
    emphasis: "none" | "50/15" | "CcitJ17";
    sampleData: Uint8Array;
}
export declare const $Mp3Frame: DocumentIoType<Mp3Frame>;
