import { DocumentIoType } from "kryo/types/document";
import { Sint16, Uint16, UintSize } from "semantic-types";
import { Rect } from "../rect";
import { StraightSRgba8 } from "../straight-s-rgba8";
import { TextAlignment } from "../text/text-alignment";
import { _Tag } from "./_tag";
import { TagType } from "./_type";
export interface DefineDynamicText extends _Tag {
    readonly type: TagType.DefineDynamicText;
    readonly id: Uint16;
    readonly bounds: Rect;
    readonly wordWrap: boolean;
    readonly multiline: boolean;
    readonly password: boolean;
    readonly readonly: boolean;
    readonly autoSize: boolean;
    readonly noSelect: boolean;
    readonly border: boolean;
    readonly wasStatic: boolean;
    readonly html: boolean;
    readonly useGlyphFont: boolean;
    readonly fontId?: Uint16;
    readonly fontClass?: string;
    readonly fontSize?: Uint16;
    readonly color?: StraightSRgba8;
    readonly maxLength?: UintSize;
    readonly align: TextAlignment;
    readonly marginLeft: Uint16;
    readonly marginRight: Uint16;
    readonly indent: Uint16;
    readonly leading: Sint16;
    readonly variableName?: string;
    readonly text?: string;
}
export declare const $DefineDynamicText: DocumentIoType<DefineDynamicText>;
