import { DocumentIoType } from "kryo/types/document";
import { Uint16 } from "semantic-types";
import { Glyph } from "../glyph";
import { LanguageCode } from "../language-code";
import { EmSquareSize } from "../text/em-square-size";
import { FontLayout } from "../text/font-layout";
import { _Tag } from "./_tag";
import { TagType } from "./_type";
export interface DefineFont extends _Tag {
    readonly type: TagType.DefineFont;
    readonly id: Uint16;
    readonly fontName: string;
    readonly isBold: boolean;
    readonly isItalic: boolean;
    readonly isAnsi: boolean;
    readonly isSmall: boolean;
    readonly isShiftJis: boolean;
    readonly emSquareSize: EmSquareSize;
    readonly language: LanguageCode;
    readonly glyphs?: ReadonlyArray<Glyph>;
    readonly codeUnits?: ReadonlyArray<Uint16>;
    readonly layout?: FontLayout;
}
export declare const $DefineFont: DocumentIoType<DefineFont>;
