import { DocumentIoType } from "kryo/types/document";
import { Uint16, Uint32 } from "semantic-types";
import { AudioCodingFormat } from "../sound/audio-coding-format";
import { SoundRate } from "../sound/sound-rate";
import { SoundSize } from "../sound/sound-size";
import { SoundType } from "../sound/sound-type";
import { _Tag } from "../tags/_tag";
import { TagType } from "../tags/_type";
export interface DefineSound extends _Tag {
    readonly type: TagType.DefineSound;
    readonly id: Uint16;
    readonly soundType: SoundType;
    readonly soundSize: SoundSize;
    readonly soundRate: SoundRate;
    readonly format: AudioCodingFormat;
    readonly sampleCount: Uint32;
    readonly data: Uint8Array;
}
export declare const $DefineSound: DocumentIoType<DefineSound>;
