import { DocumentIoType } from "kryo/types/document";
import { Uint16 } from "semantic-types";
import { BlendMode } from "../blend-mode";
import { ClipAction } from "../clip-action";
import { ColorTransformWithAlpha } from "../color-transform-with-alpha";
import { Filter } from "../filter";
import { Matrix } from "../matrix";
import { StraightSRgba8 } from "../straight-s-rgba8";
import { _Tag } from "./_tag";
import { TagType } from "./_type";
export interface PlaceObject extends _Tag {
    readonly type: TagType.PlaceObject;
    readonly isUpdate: boolean;
    readonly depth: Uint16;
    readonly characterId?: Uint16;
    readonly className?: string;
    readonly matrix?: Matrix;
    readonly colorTransform?: ColorTransformWithAlpha;
    readonly ratio?: Uint16;
    readonly name?: string;
    readonly clipDepth?: Uint16;
    readonly filters?: ReadonlyArray<Filter>;
    readonly blendMode?: BlendMode;
    readonly bitmapCache?: boolean;
    readonly visible?: boolean;
    readonly backgroundColor?: StraightSRgba8;
    readonly clipActions?: ReadonlyArray<ClipAction>;
}
export declare const $PlaceObject: DocumentIoType<PlaceObject>;
