import { DocumentIoType } from "kryo/types/document";
import { Sint16, Uint16 } from "semantic-types";
import { AudioCodingFormat } from "../sound/audio-coding-format";
import { SoundRate } from "../sound/sound-rate";
import { SoundSize } from "../sound/sound-size";
import { SoundType } from "../sound/sound-type";
import { _Tag } from "./_tag";
import { TagType } from "./_type";
export interface SoundStreamHead extends _Tag {
    readonly type: TagType.SoundStreamHead;
    readonly playbackSoundType: SoundType;
    readonly playbackSoundSize: SoundSize;
    readonly playbackSoundRate: SoundRate;
    readonly streamSoundType: SoundType;
    readonly streamSoundSize: SoundSize;
    readonly streamSoundRate: SoundRate;
    readonly streamFormat: AudioCodingFormat;
    readonly streamSampleCount: Uint16;
    readonly latencySeek?: Sint16;
}
export declare const $SoundStreamHead: DocumentIoType<SoundStreamHead>;
